From 466e85ccf4124f41650ae537fc4a757f55348aab Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Laur=C3=A9line=20Gu=C3=A9rin?= <zebuline@entrouvert.com>
Date: Mon, 21 Oct 2019 09:38:35 +0200
Subject: [PATCH] misc: complete existing migrations (#37086)

---
 .../apps/api_entreprise/migrations/0001_initial.py |  2 +-
 passerelle/apps/astregs/migrations/0001_initial.py |  2 +-
 passerelle/apps/choosit/migrations/0001_initial.py |  4 ++--
 .../0005_choositsmsgateway_default_trunk_prefix.py |  2 +-
 passerelle/apps/cmis/migrations/0001_initial.py    |  2 +-
 .../apps/csvdatasource/migrations/0007_query.py    |  2 +-
 passerelle/apps/mobyt/migrations/0001_initial.py   |  8 ++++----
 .../0005_mobytsmsgateway_default_trunk_prefix.py   |  2 +-
 .../opengis/migrations/0004_auto_20180219_1613.py  |  2 +-
 passerelle/apps/ovh/migrations/0001_initial.py     | 14 +++++++-------
 .../0005_ovhsmsgateway_default_trunk_prefix.py     |  2 +-
 passerelle/apps/oxyd/migrations/0001_initial.py    |  6 +++---
 .../0005_oxydsmsgateway_default_trunk_prefix.py    |  2 +-
 passerelle/apps/sp_fr/migrations/0001_initial.py   |  4 ++--
 .../base/migrations/0007_loggingparameters.py      |  2 +-
 15 files changed, 28 insertions(+), 28 deletions(-)

diff --git a/passerelle/apps/api_entreprise/migrations/0001_initial.py b/passerelle/apps/api_entreprise/migrations/0001_initial.py
index bd75c778..f1cdc0ca 100644
--- a/passerelle/apps/api_entreprise/migrations/0001_initial.py
+++ b/passerelle/apps/api_entreprise/migrations/0001_initial.py
@@ -23,7 +23,7 @@ class Migration(migrations.Migration):
                 ('slug', models.SlugField(unique=True, verbose_name='Identifier')),
                 ('url', models.URLField(default=b'https://entreprise.api.gouv.fr/v2/', max_length=256, verbose_name='API URL')),
                 ('token', models.CharField(max_length=1024, verbose_name='API token')),
-                ('users', models.ManyToManyField(blank=True, to='base.ApiUser')),
+                ('users', models.ManyToManyField(blank=True, related_name='_apientreprise_users_+', related_query_name='+', to='base.ApiUser')),
             ],
             options={
                 'verbose_name': 'API Entreprise',
diff --git a/passerelle/apps/astregs/migrations/0001_initial.py b/passerelle/apps/astregs/migrations/0001_initial.py
index d2130460..6848e27b 100644
--- a/passerelle/apps/astregs/migrations/0001_initial.py
+++ b/passerelle/apps/astregs/migrations/0001_initial.py
@@ -25,7 +25,7 @@ class Migration(migrations.Migration):
                 ('wsdl_base_url', models.URLField(verbose_name='Webservices base URL')),
                 ('username', models.CharField(max_length=32, verbose_name='Username')),
                 ('password', models.CharField(max_length=32, verbose_name='Password')),
-                ('organism', models.CharField(max_length=32, verbose_name='Organism')),
+                ('organism', models.CharField(max_length=32, verbose_name='Organisme')),
                 ('budget', models.CharField(max_length=32, verbose_name='Budget')),
                 ('exercice', models.CharField(max_length=32, verbose_name='Exercice')),
                 ('users', models.ManyToManyField(blank=True, related_name='_astregs_users_+', related_query_name='+', to='base.ApiUser')),
diff --git a/passerelle/apps/choosit/migrations/0001_initial.py b/passerelle/apps/choosit/migrations/0001_initial.py
index 47f13e02..f6ced43e 100644
--- a/passerelle/apps/choosit/migrations/0001_initial.py
+++ b/passerelle/apps/choosit/migrations/0001_initial.py
@@ -48,8 +48,8 @@ class Migration(migrations.Migration):
                 ('title', models.CharField(verbose_name='Title', max_length=50)),
                 ('slug', models.SlugField(verbose_name='Identifier', unique=True)),
                 ('description', models.TextField(verbose_name='Description')),
-                ('key', models.CharField(max_length=64)),
-                ('default_country_code', models.CharField(default='33', max_length=3)),
+                ('key', models.CharField(max_length=64, verbose_name='Key')),
+                ('default_country_code', models.CharField(default='33', max_length=3, verbose_name='Default country code')),
                 ('users', models.ManyToManyField(to='base.ApiUser', related_name='_choositsmsgateway_users_+', related_query_name='+', blank=True)),
             ],
             options={
diff --git a/passerelle/apps/choosit/migrations/0005_choositsmsgateway_default_trunk_prefix.py b/passerelle/apps/choosit/migrations/0005_choositsmsgateway_default_trunk_prefix.py
index d85d3d43..8a1fad75 100644
--- a/passerelle/apps/choosit/migrations/0005_choositsmsgateway_default_trunk_prefix.py
+++ b/passerelle/apps/choosit/migrations/0005_choositsmsgateway_default_trunk_prefix.py
@@ -14,7 +14,7 @@ class Migration(migrations.Migration):
         migrations.AddField(
             model_name='choositsmsgateway',
             name='default_trunk_prefix',
-            field=models.CharField(default='0', max_length=2),
+            field=models.CharField(default='0', max_length=2, verbose_name='Default trunk prefix'),
             preserve_default=True,
         ),
     ]
diff --git a/passerelle/apps/cmis/migrations/0001_initial.py b/passerelle/apps/cmis/migrations/0001_initial.py
index 03b8143b..7e6693e0 100644
--- a/passerelle/apps/cmis/migrations/0001_initial.py
+++ b/passerelle/apps/cmis/migrations/0001_initial.py
@@ -21,7 +21,7 @@ class Migration(migrations.Migration):
                 ('log_level', models.CharField(default=b'INFO', max_length=10, verbose_name='Log Level', choices=[(b'NOTSET', b'NOTSET'), (b'DEBUG', b'DEBUG'), (b'INFO', b'INFO'), (b'WARNING', b'WARNING'), (b'ERROR', b'ERROR'), (b'CRITICAL', b'CRITICAL')])),
                 ('cmis_endpoint', models.URLField(help_text='URL of the CMIS Atom endpoint', max_length=400, verbose_name='CMIS Atom endpoint')),
                 ('username', models.CharField(max_length=128, verbose_name='Service username')),
-                ('password', models.CharField(max_length=128, verbose_name='Password')),
+                ('password', models.CharField(max_length=128, verbose_name='Service password')),
                 ('users', models.ManyToManyField(to='base.ApiUser', related_name='_cmisconnector_users_+', related_query_name='+', blank=True)),
             ],
             options={
diff --git a/passerelle/apps/csvdatasource/migrations/0007_query.py b/passerelle/apps/csvdatasource/migrations/0007_query.py
index 24493d66..81f97118 100644
--- a/passerelle/apps/csvdatasource/migrations/0007_query.py
+++ b/passerelle/apps/csvdatasource/migrations/0007_query.py
@@ -20,7 +20,7 @@ class Migration(migrations.Migration):
                 ('projections', models.TextField(help_text='List of projections (name:expression)', verbose_name='Projections', blank=True)),
                 ('order', models.TextField(help_text='Columns to use for sorting rows', verbose_name='Sort Order', blank=True)),
                 ('distinct', models.TextField(help_text='Distinct columns', verbose_name='Distinct', blank=True)),
-                ('structure', models.CharField(default=b'dict', help_text='Data structure used for the response', max_length=20, verbose_name='Structure', choices=[(b'array', 'Array'), (b'dict', 'Dictionary'), (b'tuples', 'Tuples'), (b'onerow', 'Single Row'), (b'one', 'Single Value')])),
+                ('structure', models.CharField(choices=[(b'array', 'Array'), (b'dict', 'Dictionary'), (b'keyed-distinct', 'Keyed Dictionary'), (b'tuples', 'Tuples'), (b'onerow', 'Single Row'), (b'one', 'Single Value')], default=b'dict', help_text='Data structure used for the response', max_length=20, verbose_name='Structure')),
                 ('resource', models.ForeignKey(to='csvdatasource.CsvDataSource', on_delete=models.CASCADE)),
             ],
             options={
diff --git a/passerelle/apps/mobyt/migrations/0001_initial.py b/passerelle/apps/mobyt/migrations/0001_initial.py
index 94efd8f5..a4a3846b 100644
--- a/passerelle/apps/mobyt/migrations/0001_initial.py
+++ b/passerelle/apps/mobyt/migrations/0001_initial.py
@@ -19,10 +19,10 @@ class Migration(migrations.Migration):
                 ('title', models.CharField(verbose_name='Title', max_length=50)),
                 ('slug', models.SlugField(verbose_name='Identifier', unique=True)),
                 ('description', models.TextField(verbose_name='Description')),
-                ('username', models.CharField(max_length=64)),
-                ('password', models.CharField(max_length=64)),
-                ('quality', models.CharField(default=b'l', max_length=4, verbose_name='message quality', choices=[(b'l', 'sms direct'), (b'll', 'sms low-cost'), (b'n', 'sms top')])),
-                ('default_country_code', models.CharField(default='33', max_length=3)),
+                ('username', models.CharField(max_length=64, verbose_name='Username')),
+                ('password', models.CharField(max_length=64, verbose_name='Password')),
+                ('quality', models.CharField(choices=[(b'l', 'sms direct'), (b'll', 'sms low-cost'), (b'n', 'sms top')], default=b'l', max_length=4, verbose_name='Message quality')),
+                ('default_country_code', models.CharField(default='33', max_length=3, verbose_name='Default country code')),
                 ('users', models.ManyToManyField(to='base.ApiUser', related_name='_mobytsmsgateway_users_+', related_query_name='+', blank=True)),
             ],
             options={
diff --git a/passerelle/apps/mobyt/migrations/0005_mobytsmsgateway_default_trunk_prefix.py b/passerelle/apps/mobyt/migrations/0005_mobytsmsgateway_default_trunk_prefix.py
index fcfe2f22..bba773dc 100644
--- a/passerelle/apps/mobyt/migrations/0005_mobytsmsgateway_default_trunk_prefix.py
+++ b/passerelle/apps/mobyt/migrations/0005_mobytsmsgateway_default_trunk_prefix.py
@@ -14,7 +14,7 @@ class Migration(migrations.Migration):
         migrations.AddField(
             model_name='mobytsmsgateway',
             name='default_trunk_prefix',
-            field=models.CharField(default='0', max_length=2),
+            field=models.CharField(default='0', max_length=2, verbose_name='Default trunk prefix'),
             preserve_default=True,
         ),
     ]
diff --git a/passerelle/apps/opengis/migrations/0004_auto_20180219_1613.py b/passerelle/apps/opengis/migrations/0004_auto_20180219_1613.py
index 08ea9a1d..2643bc30 100644
--- a/passerelle/apps/opengis/migrations/0004_auto_20180219_1613.py
+++ b/passerelle/apps/opengis/migrations/0004_auto_20180219_1613.py
@@ -14,6 +14,6 @@ class Migration(migrations.Migration):
         migrations.AddField(
             model_name='opengis',
             name='projection',
-            field=models.CharField(default=b'EPSG:3857', max_length=16, verbose_name='GIS projection', choices=[(b'EPSG:4326', 'EPSG:4326 (WGS 84)'), (b'EPSG:2154', 'EPSG:2154 (Lambert-93)'), (b'EPSG:3857', 'EPSG:3857 (WGS84 / Pseudo-Mercator)'), (b'EPSG:3945', 'EPSG:3945 (CC45)')]),
+            field=models.CharField(choices=[(b'EPSG:2154', 'EPSG:2154 (Lambert-93)'), (b'EPSG:3857', 'EPSG:3857 (WGS 84 / Pseudo-Mercator)'), (b'EPSG:3945', 'EPSG:3945 (CC45)'), (b'EPSG:4326', 'EPSG:4326 (WGS 84)')], default=b'EPSG:3857', max_length=16, verbose_name='GIS projection'),
         ),
     ]
diff --git a/passerelle/apps/ovh/migrations/0001_initial.py b/passerelle/apps/ovh/migrations/0001_initial.py
index eed4013c..2f6c058c 100644
--- a/passerelle/apps/ovh/migrations/0001_initial.py
+++ b/passerelle/apps/ovh/migrations/0001_initial.py
@@ -19,13 +19,13 @@ class Migration(migrations.Migration):
                 ('title', models.CharField(verbose_name='Title', max_length=50)),
                 ('slug', models.SlugField(verbose_name='Identifier', unique=True)),
                 ('description', models.TextField(verbose_name='Description')),
-                ('account', models.CharField(max_length=64)),
-                ('username', models.CharField(max_length=64)),
-                ('password', models.CharField(max_length=64)),
-                ('msg_class', models.IntegerField(default=1, verbose_name='message class', choices=[(0, 'Message are directly shown to users on phone screen at reception. The message is never stored, neither in the phone memory nor in the SIM card. It is deleted as soon as the user validate the display.'), (1, 'Messages are stored in the phone memory, or in the SIM card if the memory is full. '), (2, 'Messages are stored in the SIM card.'), (3, 'Messages are stored in external storage like a PDA or a PC.')])),
-                ('credit_threshold_alert', models.PositiveIntegerField(default=100)),
-                ('default_country_code', models.CharField(default='33', max_length=3)),
-                ('credit_left', models.PositiveIntegerField(default=0)),
+                ('account', models.CharField(max_length=64, verbose_name='Account')),
+                ('username', models.CharField(max_length=64, verbose_name='Username')),
+                ('password', models.CharField(max_length=64, verbose_name='Password')),
+                ('msg_class', models.IntegerField(choices=[(0, 'Message are directly shown to users on phone screen at reception. The message is never stored, neither in the phone memory nor in the SIM card. It is deleted as soon as the user validate the display.'), (1, 'Messages are stored in the phone memory, or in the SIM card if the memory is full. '), (2, 'Messages are stored in the SIM card.'), (3, 'Messages are stored in external storage like a PDA or a PC.')], default=1, verbose_name='Message class')),
+                ('credit_threshold_alert', models.PositiveIntegerField(default=100, verbose_name='Credit alert threshold')),
+                ('default_country_code', models.CharField(default='33', max_length=3, verbose_name='Default country code')),
+                ('credit_left', models.PositiveIntegerField(default=0, verbose_name='Credit left')),
                 ('users', models.ManyToManyField(to='base.ApiUser', related_name='_ovhsmsgateway_users_+', related_query_name='+', blank=True)),
             ],
             options={
diff --git a/passerelle/apps/ovh/migrations/0005_ovhsmsgateway_default_trunk_prefix.py b/passerelle/apps/ovh/migrations/0005_ovhsmsgateway_default_trunk_prefix.py
index e9a65b8b..1d2fb8c7 100644
--- a/passerelle/apps/ovh/migrations/0005_ovhsmsgateway_default_trunk_prefix.py
+++ b/passerelle/apps/ovh/migrations/0005_ovhsmsgateway_default_trunk_prefix.py
@@ -14,7 +14,7 @@ class Migration(migrations.Migration):
         migrations.AddField(
             model_name='ovhsmsgateway',
             name='default_trunk_prefix',
-            field=models.CharField(default='0', max_length=2),
+            field=models.CharField(default='0', max_length=2, verbose_name='Default trunk prefix'),
             preserve_default=True,
         ),
     ]
diff --git a/passerelle/apps/oxyd/migrations/0001_initial.py b/passerelle/apps/oxyd/migrations/0001_initial.py
index 95f7258e..5510816f 100644
--- a/passerelle/apps/oxyd/migrations/0001_initial.py
+++ b/passerelle/apps/oxyd/migrations/0001_initial.py
@@ -19,9 +19,9 @@ class Migration(migrations.Migration):
                 ('title', models.CharField(verbose_name='Title', max_length=50)),
                 ('slug', models.SlugField(verbose_name='Identifier', unique=True)),
                 ('description', models.TextField(verbose_name='Description')),
-                ('username', models.CharField(max_length=64)),
-                ('password', models.CharField(max_length=64)),
-                ('default_country_code', models.CharField(default='33', max_length=3)),
+                ('username', models.CharField(max_length=64, verbose_name='Username')),
+                ('password', models.CharField(max_length=64, verbose_name='Password')),
+                ('default_country_code', models.CharField(default='33', max_length=3, verbose_name='Default country code')),
                 ('users', models.ManyToManyField(to='base.ApiUser', related_name='_oxydsmsgateway_users_+', related_query_name='+', blank=True)),
             ],
             options={
diff --git a/passerelle/apps/oxyd/migrations/0005_oxydsmsgateway_default_trunk_prefix.py b/passerelle/apps/oxyd/migrations/0005_oxydsmsgateway_default_trunk_prefix.py
index a5c6c783..4154b5c7 100644
--- a/passerelle/apps/oxyd/migrations/0005_oxydsmsgateway_default_trunk_prefix.py
+++ b/passerelle/apps/oxyd/migrations/0005_oxydsmsgateway_default_trunk_prefix.py
@@ -14,7 +14,7 @@ class Migration(migrations.Migration):
         migrations.AddField(
             model_name='oxydsmsgateway',
             name='default_trunk_prefix',
-            field=models.CharField(default='0', max_length=2),
+            field=models.CharField(default='0', max_length=2, verbose_name='Default trunk prefix'),
             preserve_default=True,
         ),
     ]
diff --git a/passerelle/apps/sp_fr/migrations/0001_initial.py b/passerelle/apps/sp_fr/migrations/0001_initial.py
index 38579090..59dd6169 100644
--- a/passerelle/apps/sp_fr/migrations/0001_initial.py
+++ b/passerelle/apps/sp_fr/migrations/0001_initial.py
@@ -23,7 +23,7 @@ class Migration(migrations.Migration):
             name='Mapping',
             fields=[
                 ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
-                ('procedure', models.CharField(choices=[(b'DOC', 'Request for construction site opening'), (b'RCO', 'Request for mandatory citizen census'), (b'DDPACS', 'Pre-request for citizen solidarity pact')], max_length=32, unique=True, verbose_name='Procedure')),
+                ('procedure', models.CharField(choices=[(b'DOC', 'Request for construction site opening'), (b'recensementCitoyen', 'Request for mandatory citizen census'), (b'depotDossierPACS', 'Pre-request for citizen solidarity pact')], max_length=32, unique=True, verbose_name='Procedure')),
                 ('formdef', passerelle.utils.wcs.FormDefField(verbose_name='Formdef')),
                 ('rules', jsonfield.fields.JSONField(default=passerelle.apps.sp_fr.models.default_rule, verbose_name='Rules')),
             ],
@@ -40,7 +40,7 @@ class Migration(migrations.Migration):
                 ('modified', models.DateTimeField(auto_now=True, verbose_name='Created')),
                 ('filename', models.CharField(max_length=128, verbose_name='Identifier')),
                 ('archive', models.FileField(max_length=256, upload_to=b'', verbose_name='Archive')),
-                ('state', models.CharField(choices=[(b'received', 'Received'), (b'transfered', 'Transfered'), (b'error', 'Transfered'), (b'returned', 'Returned')], default=b'received', max_length=16, verbose_name='State')),
+                ('state', models.CharField(choices=[(b'received', 'Received'), (b'transfered', 'Transferred'), (b'error', 'Error'), (b'returned', 'Returned')], default=b'received', max_length=16, verbose_name='State')),
                 ('url', models.URLField(blank=True, verbose_name='URL')),
             ],
             options={
diff --git a/passerelle/base/migrations/0007_loggingparameters.py b/passerelle/base/migrations/0007_loggingparameters.py
index dd37a4c6..5cd96e45 100644
--- a/passerelle/base/migrations/0007_loggingparameters.py
+++ b/passerelle/base/migrations/0007_loggingparameters.py
@@ -19,7 +19,7 @@ class Migration(migrations.Migration):
             fields=[
                 ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                 ('resource_pk', models.PositiveIntegerField()),
-                ('log_level', models.CharField(verbose_name='Log Level', choices=[(b'DEBUG', b'DEBUG'), (b'INFO', b'INFO'), (b'WARNING', b'WARNING'), (b'ERROR', b'ERROR'), (b'CRITICAL', b'CRITICAL')], default=b'INFO', max_length=10)),
+                ('log_level', models.CharField(choices=[(b'DEBUG', 'Debug'), (b'INFO', 'Info'), (b'WARNING', 'Warning'), (b'ERROR', 'Error'), (b'CRITICAL', 'Critical')], default=b'INFO', max_length=10, verbose_name='Log level')),
                 ('resource_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
             ],
         ),
-- 
2.20.1